/* Generated by wayland-scanner 1.13.0 */

#ifndef OUTPUTMANAGEMENT_CLIENT_PROTOCOL_H
#define OUTPUTMANAGEMENT_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_outputmanagement The outputmanagement protocol
 * @section page_ifaces_outputmanagement Interfaces
 * - @subpage page_iface_org_kde_kwin_outputmanagement - list connected, but disabled outputs
 * - @subpage page_iface_org_kde_kwin_outputconfiguration - list connected, but disabled outputs
 * @section page_copyright_outputmanagement Copyright
 * <pre>
 *
 * Copyright © 2015 Sebastian Kügler <sebas@kde.org>
 * Copyright © 2008-2011 Kristian Høgsberg
 * Copyright © 2010-2011 Intel Corporation
 * Copyright © 2012-2013 Collabora, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 * </pre>
 */
struct org_kde_kwin_outputconfiguration;
struct org_kde_kwin_outputdevice;
struct org_kde_kwin_outputmanagement;

/**
 * @page page_iface_org_kde_kwin_outputmanagement org_kde_kwin_outputmanagement
 * @section page_iface_org_kde_kwin_outputmanagement_desc Description
 *
 * This interface allows to connected output devices for screen configuration purposes.
 *
 * OutputManagement (wl_global)
 * --------------------------
 * request:
 * * createConfiguration -> OutputConfiguration (wl_resource)
 *
 * OutputConfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output, bool)
 * * mode(output, mode_id)
 * * transformation(output, flag)
 * * position(output, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The idea is that we register one OutputManagement as a global. When KScreen
 * wants to configure it calls createConfiguration which provides a resource
 * referencing an OutputConfiguration for one-time configuration. That way we can
 * easily group all requests and know on the server which one belong together. On
 * the OutputConfiguration it calls for each Output whether it's enabled, which
 * mode to use (by referencing the mode from the list of announced modes) and the
 * global position. Once all outputs are configured that way, it calls apply.  At
 * that point and not earlier the server emits a signal to KWin with the complete
 * wanted configuration which KWin can then try to apply. If that succeeds it
 * emits the applied signal, otherwise the failed. So even KScreen can know about
 * it.
 *
 * That interface is nicely atomic (as KWin only gets the apply for everything
 * setup), it solves the 1:n mapping problem: each OutputConfiguration is only a
 * 1:1 mapping, and we do not need to copy all the requests again by just
 * referencing a mode id.
 *
 *
 * @section page_iface_org_kde_kwin_outputmanagement_api API
 * See @ref iface_org_kde_kwin_outputmanagement.
 */
/**
 * @defgroup iface_org_kde_kwin_outputmanagement The org_kde_kwin_outputmanagement interface
 *
 * This interface allows to connected output devices for screen configuration purposes.
 *
 * OutputManagement (wl_global)
 * --------------------------
 * request:
 * * createConfiguration -> OutputConfiguration (wl_resource)
 *
 * OutputConfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output, bool)
 * * mode(output, mode_id)
 * * transformation(output, flag)
 * * position(output, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The idea is that we register one OutputManagement as a global. When KScreen
 * wants to configure it calls createConfiguration which provides a resource
 * referencing an OutputConfiguration for one-time configuration. That way we can
 * easily group all requests and know on the server which one belong together. On
 * the OutputConfiguration it calls for each Output whether it's enabled, which
 * mode to use (by referencing the mode from the list of announced modes) and the
 * global position. Once all outputs are configured that way, it calls apply.  At
 * that point and not earlier the server emits a signal to KWin with the complete
 * wanted configuration which KWin can then try to apply. If that succeeds it
 * emits the applied signal, otherwise the failed. So even KScreen can know about
 * it.
 *
 * That interface is nicely atomic (as KWin only gets the apply for everything
 * setup), it solves the 1:n mapping problem: each OutputConfiguration is only a
 * 1:1 mapping, and we do not need to copy all the requests again by just
 * referencing a mode id.
 *
 *
 */
extern const struct wl_interface org_kde_kwin_outputmanagement_interface;
/**
 * @page page_iface_org_kde_kwin_outputconfiguration org_kde_kwin_outputconfiguration
 * @section page_iface_org_kde_kwin_outputconfiguration_desc Description
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the compositor to apply changes to the outputdevices, the monitors connected
 * to the system.
 * The client receives a list of outputdevices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the compositor to apply these settings
 * in an atomic fashion, for example through Linux's DRM interface.
 * The compositor signals back whether the new settings have applied successfully
 * or failed to apply. outputdevices are updated after the hardware changes have
 * been applied and before the server side fires applied.
 * @section page_iface_org_kde_kwin_outputconfiguration_api API
 * See @ref iface_org_kde_kwin_outputconfiguration.
 */
/**
 * @defgroup iface_org_kde_kwin_outputconfiguration The org_kde_kwin_outputconfiguration interface
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the compositor to apply changes to the outputdevices, the monitors connected
 * to the system.
 * The client receives a list of outputdevices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the compositor to apply these settings
 * in an atomic fashion, for example through Linux's DRM interface.
 * The compositor signals back whether the new settings have applied successfully
 * or failed to apply. outputdevices are updated after the hardware changes have
 * been applied and before the server side fires applied.
 */
extern const struct wl_interface org_kde_kwin_outputconfiguration_interface;

#define ORG_KDE_KWIN_OUTPUTMANAGEMENT_CREATE_CONFIGURATION 0


/**
 * @ingroup iface_org_kde_kwin_outputmanagement
 */
#define ORG_KDE_KWIN_OUTPUTMANAGEMENT_CREATE_CONFIGURATION_SINCE_VERSION 1

/** @ingroup iface_org_kde_kwin_outputmanagement */
static inline void
org_kde_kwin_outputmanagement_set_user_data(struct org_kde_kwin_outputmanagement *org_kde_kwin_outputmanagement, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) org_kde_kwin_outputmanagement, user_data);
}

/** @ingroup iface_org_kde_kwin_outputmanagement */
static inline void *
org_kde_kwin_outputmanagement_get_user_data(struct org_kde_kwin_outputmanagement *org_kde_kwin_outputmanagement)
{
	return wl_proxy_get_user_data((struct wl_proxy *) org_kde_kwin_outputmanagement);
}

static inline uint32_t
org_kde_kwin_outputmanagement_get_version(struct org_kde_kwin_outputmanagement *org_kde_kwin_outputmanagement)
{
	return wl_proxy_get_version((struct wl_proxy *) org_kde_kwin_outputmanagement);
}

/** @ingroup iface_org_kde_kwin_outputmanagement */
static inline void
org_kde_kwin_outputmanagement_destroy(struct org_kde_kwin_outputmanagement *org_kde_kwin_outputmanagement)
{
	wl_proxy_destroy((struct wl_proxy *) org_kde_kwin_outputmanagement);
}

/**
 * @ingroup iface_org_kde_kwin_outputmanagement
 *
 * Request an output configuration, which can be changed and then applied.
 */
static inline struct org_kde_kwin_outputconfiguration *
org_kde_kwin_outputmanagement_create_configuration(struct org_kde_kwin_outputmanagement *org_kde_kwin_outputmanagement)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) org_kde_kwin_outputmanagement,
			 ORG_KDE_KWIN_OUTPUTMANAGEMENT_CREATE_CONFIGURATION, &org_kde_kwin_outputconfiguration_interface, NULL);

	return (struct org_kde_kwin_outputconfiguration *) id;
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 * @struct org_kde_kwin_outputconfiguration_listener
 */
struct org_kde_kwin_outputconfiguration_listener {
	/**
	 * configuration changes have been applied
	 *
	 * Fired after the compositor has applied the changes
	 * successfully.
	 */
	void (*applied)(void *data,
			struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration);
	/**
	 * configuration changes failed to apply
	 *
	 * Fired if the compositor rejects or failed to apply the
	 * changes.
	 */
	void (*failed)(void *data,
		       struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration);
};

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
static inline int
org_kde_kwin_outputconfiguration_add_listener(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration,
					      const struct org_kde_kwin_outputconfiguration_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) org_kde_kwin_outputconfiguration,
				     (void (**)(void)) listener, data);
}

#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_ENABLE 0
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_MODE 1
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_TRANSFORM 2
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_POSITION 3
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_SCALE 4
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLY 5

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLIED_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_FAILED_SINCE_VERSION 1

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_ENABLE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_SCALE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLY_SINCE_VERSION 1

/** @ingroup iface_org_kde_kwin_outputconfiguration */
static inline void
org_kde_kwin_outputconfiguration_set_user_data(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) org_kde_kwin_outputconfiguration, user_data);
}

/** @ingroup iface_org_kde_kwin_outputconfiguration */
static inline void *
org_kde_kwin_outputconfiguration_get_user_data(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration)
{
	return wl_proxy_get_user_data((struct wl_proxy *) org_kde_kwin_outputconfiguration);
}

static inline uint32_t
org_kde_kwin_outputconfiguration_get_version(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration)
{
	return wl_proxy_get_version((struct wl_proxy *) org_kde_kwin_outputconfiguration);
}

/** @ingroup iface_org_kde_kwin_outputconfiguration */
static inline void
org_kde_kwin_outputconfiguration_destroy(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration)
{
	wl_proxy_destroy((struct wl_proxy *) org_kde_kwin_outputconfiguration);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Mark the output as enabled or disabled.
 */
static inline void
org_kde_kwin_outputconfiguration_enable(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, struct org_kde_kwin_outputdevice *outputdevice, int32_t enable)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_ENABLE, outputdevice, enable);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Sets the mode for a given output by its mode size (width and height) and refresh rate.
 */
static inline void
org_kde_kwin_outputconfiguration_mode(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, struct org_kde_kwin_outputdevice *outputdevice, int32_t mode_id)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_MODE, outputdevice, mode_id);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Sets the transformation for a given output.
 */
static inline void
org_kde_kwin_outputconfiguration_transform(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, struct org_kde_kwin_outputdevice *outputdevice, int32_t transform)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_TRANSFORM, outputdevice, transform);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Sets the position for this output device in the global space. position
 * describes the top-left border of the output in the global space. The
 * left-most output's top-left border is 0, 0.
 * There may be no gaps between outputs, the outputs have to be positioned
 * stacked horizontally, vertically, or both.
 */
static inline void
org_kde_kwin_outputconfiguration_position(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, struct org_kde_kwin_outputdevice *outputdevice, int32_t x, int32_t y)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_POSITION, outputdevice, x, y);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Sets the scaling factor for this outputdevice.
 */
static inline void
org_kde_kwin_outputconfiguration_scale(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration, struct org_kde_kwin_outputdevice *outputdevice, int32_t scale)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_SCALE, outputdevice, scale);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 *
 * Asks the compositor to apply changes to the outputdevices on the server side.
 */
static inline void
org_kde_kwin_outputconfiguration_apply(struct org_kde_kwin_outputconfiguration *org_kde_kwin_outputconfiguration)
{
	wl_proxy_marshal((struct wl_proxy *) org_kde_kwin_outputconfiguration,
			 ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLY);
}

#ifdef  __cplusplus
}
#endif

#endif
